import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class Plante {
    Planta[] PlantaA;
    int pozitie;
    int NMAX = 100;
    File f = new File("plante.dat");

    public Plante() {
        if (incarcaPlante()) {
            NMAX = PlantaA.length;
            pozitie = 0;
            for(int i=0;i<NMAX;++i)
                if (PlantaA[i] != null) pozitie++;  
        } else {
            PlantaA = new Planta[NMAX];
            pozitie = 0;
        }
    }

    public void adaguaPlanta(Planta p) {
        if (pozitie < NMAX) {
            PlantaA[pozitie++] = p;
            salvareModificare();
        }
    }

    public boolean modificaPlanta(String cheie, int cantitate9) {
        for (Planta p : PlantaA) {
            if (p.getNume().equals(cheie)) {
                p.setCantitate(p.getCantitate() - cantitate9);
                salvareModificare();
                return true;
            }   
        }
        return false;
    }

    public boolean incarcaPlante() {
        ObjectInputStream in;
        try {
            in = new ObjectInputStream(new FileInputStream(f));
            PlantaA = (Planta[])in.readObject();
            in.close();
            System.out.println(PlantaA.length + " au fost incarcate.");

            return true;
        } catch (IOException e) {
            System.out.println(e);
        } catch (ClassNotFoundException e) {
            System.out.println(e);
        }
        return false;
    }

    public boolean salvareModificare() {
        ObjectOutputStream out;

        try {
            out = new ObjectOutputStream(new FileOutputStream(f));
            out.writeObject(PlantaA);
            out.close();
            out = null;
            System.gc();

            return true;
        } catch (IOException e) {
            System.out.println(e);
        }
        return false;
    }

    public String toString() {
        String rez = "";
        for (Planta p : PlantaA) {
            rez += (p == null)? "" : p + "\n\n";
        }
        return rez;
    }
}
