import java.awt.Color;
import java.awt.Graphics;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

import java.util.Random;

public class Bila {
    public double Px, Py;
    public double Vx, Vy;
    public Color culoare;
    private static final int XSIZE = 30;
    private static final int YSIZE = 30;

    public Bila(int w, int h) {
        this.Px = aleator(w);
        this.Py = aleator(h);
        this.Vx = 2 - aleator(2); //1
        this.Vy = 2 - aleator(2); //1
        this.culoare = new Color(aleator(255), aleator(255), aleator(255));
    }

    public int aleator(int i) {
        Random rnd = new Random();
        return rnd.nextInt(i);
    }

    public void muta(Rectangle2D limite) {
        Px += Vx;
        Py += Vy;
        if (Px < limite.getMinX()) {
            Px = limite.getMinX();
            Vx = -Vx;
        }
        if (Px + XSIZE >= limite.getMaxX()) {
            Px = limite.getMaxX() - XSIZE;
            Vx = -Vx;
        }
        if (Py < limite.getMinY()) {
            Py = limite.getMinY();
            Vy = -Vy;
        }
        if (Py + YSIZE >= limite.getMaxY()) {
            Py = limite.getMaxY() - YSIZE;
            Vy = -Vy;
        }
    }

    public void ciocnireBila(Bila b1) {
        double dist, r1b1;
        dist = Math.sqrt((Px - b1.Px) * (Px - b1.Px) + (Py - b1.Py) * (Py - b1.Py));
        r1b1 = XSIZE / 2. + b1.XSIZE / 2.;

        if ((dist) <= r1b1) {
                Vx = -Vx;
                b1.Vx = -b1.Vx;
           
                Vy = -Vy;
                b1.Vy = -b1.Vy;
        }
    }

    public Ellipse2D desenare(Graphics g) {
        g.setColor(culoare);
        return new Ellipse2D.Double(Px, Py, XSIZE, YSIZE);
    }
}
